Package ghidra.util.database.spatial

# Class DBTreeNodeRecord<NS extends BoundingShape<NS>>

java.lang.Object
ghidra.program.database.DatabaseObject
ghidra.util.database.DBAnnotatedObject
ghidra.util.database.spatial.DBTreeRecord<NS,NS>
ghidra.util.database.spatial.DBTreeNodeRecord<NS>

Direct Known Subclasses:
  `DBTraceAddressSnapRangePropertyMapTree.DBTraceAddressSnapRangePropertyMapNode`, `DBTraceObjectValueNode`

public abstract class DBTreeNodeRecord<NS extends BoundingShape<NS>> extends DBTreeRecord<NS,NS>

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected static enum`
  `DBTreeNodeRecord.NodeType`

- ## Field Summary

  ### Fields inherited from class ghidra.program.database.DatabaseObject

  `key`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBTreeNodeRecord(DBCachedObjectStore<?> store, DBRecord record)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract int`
  `getChildCount()`
  Get the number of direct descendants of this node
  `protected abstract DBTreeNodeRecord.NodeType`
  `getType()`
  `protected abstract void`
  `setChildCount(int childCount)`
  `protected abstract void`
  `setDataCount(int dataCount)`
  `protected abstract void`
  `setType(DBTreeNodeRecord.NodeType type)`
  `String`
  `toString()`

  ### Methods inherited from class ghidra.util.database.spatial.DBTreeRecord

  `getBounds, getDataCount, getParentKey, getShape, setParentKey, setShape`

  ### Methods inherited from class ghidra.util.database.DBAnnotatedObject

  `doRefresh, doUpdateAll, doUpdated, doWrite, fresh, getObjectKey, getTableName, isDeleted, refresh, refresh, update, update, update, update`

  ### Methods inherited from class ghidra.program.database.DatabaseObject

  `checkDeleted, checkIsValid, checkIsValid, getKey, isDeleted, isInvalid, keyChanged, setDeleted, setInvalid, validate`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DBTreeNodeRecord

    public DBTreeNodeRecord(DBCachedObjectStore<?> store, DBRecord record)

- ## Method Details

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### getType

    protected abstract DBTreeNodeRecord.NodeType getType()

  - ### setType

    protected abstract void setType(DBTreeNodeRecord.NodeType type)

  - ### getChildCount

    protected abstract int getChildCount()
    Get the number of direct descendants of this node
    Returns:
      the child count

  - ### setChildCount

    protected abstract void setChildCount(int childCount)

  - ### setDataCount

    protected abstract void setDataCount(int dataCount)